/*
 *  scst_ipc.h
 *
 *  Copyright (C) 2013 Sony Corporation
 *
 *  SCSI dev handler using IPCIF.
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation, version 2
 *  of the License.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 */

#ifndef SCST_IPC_H_
#define SCST_IPC_H_

#define MAX_SGV_CNT 32

/*
 *  scst_ipc_delayed_work.c
 */
extern int scstipc_add_dmadone_work(const struct scst_cmd *cmd);

extern int scstipc_init_delayed_work(void);
extern void scstipc_exit_delayed_work(void);


/*
 *  scst_ipc_cache_ctrl.c
 */
extern void scstipc_cache_free_local_buf(struct scatterlist *sg, int sg_cnt);

extern void scstipc_check_save_cache(struct scst_cmd *cmd);
extern int scstipc_check_read_cache(struct scst_cmd *cmd);

extern int scstipc_init_dev_cache(struct scst_pcimem_dev *virt_dev);
extern void scstipc_exit_dev_cache(struct scst_pcimem_dev *virt_dev);

extern int scstipc_init_cache_ctrl(void);
extern void scstipc_exit_cache_ctrl(void);



#endif /* SCST_IPC_H_ */

/* end of scst_ipc.h */
